/* global Bdf,$$,CentralSphere,Pane */

CentralSphere.Metadata = {};

CentralSphere.Metadata.init = function (sphereName, callback) {
    CentralSphere.Ajax.loadMetadata(sphereName, function (metadata) {
        if (callback) {
            callback(sphereName, metadata);
        } else {
            CentralSphere.Metadata.load(sphereName, metadata);
        }
    });
};

CentralSphere.Metadata.load = function (sphereName, metadata) {
    var formId = Bdf.generateId();
    var attributesId = formId + "_attributes";
    $$("layout_main").html(Bdf.render("centralsphere:metadataform", {
        action: Bdf.URL + "multi-sphere",
        sphereName: sphereName,
        formId: formId,
        labelArray: Bdf.toLabelArray(metadata.labelMap),
        labelsLocKey: "_ title.multi.titlelabels_sphere",
        attributes: Bdf.attrMapToString(metadata.attrMap),
        attributesLocKey: "_ title.multi.attributes_sphere"
    }));
    Bdf.Deploy.init($$("layout_main"));
    $$(formId).ajaxForm({
        beforeSerialize: function ($form, options) {
            attributesCodeMirror.save();
            return true;
        },
        dataType: "json",
        success: function (data, textStatus, jqXHR, $form) {
            Pane.setChange(false);
            _saveCallback(data);
        }
    });
    var attributesCodeMirror = Bdf.toCodeMirror(ID(attributesId), {
        lineWrapping: false,
        lineNumbers: false,
        indentUnit: 4,
        theme: 'bdf',
        mode: "attributes"
    });
    attributesCodeMirror.on("change", function () {
        Pane.setChange(true);
    });
    Pane.checkState();
    
    
    function _saveCallback(data) {
        if (Bdf.isError(data)) {
            return;
        }
        Bdf.showCommandMessage(data.commandMessage);
        if ((data.commandMessage) && (data.commandMessage.type === "done")) {
            Bdf.updateDefaultValues($$(formId));
        }
    }
    
};
